containername=unifi_cams_events		#Name of the created docker container
deviceIP="192.168.10.1"				#Ip adress of your UniFi Device
deviceUsername="username"			#Username of LOCAL UniFi user
devicePassword="password"		#Password of LOCAL UniFi user
saveTarget="/volume1/docker/UniFiProtectFootage/Events" #Target file path where the images will be saved
timeZone="Europe/Paris"
#============== NO CHANGES BEOW THIS LINE ==========================

startPoint=$(date --date "2 day ago" +%Y-%m-%d)T00:00:00
endPoint=$(date --date "1 day ago" +%Y-%m-%d)T00:00:00


allCams=true
firstCam=true
noSubFolders=true
cams=""
startSet=false
endSet=false

while [ $# -gt 0 ]       #until parameter amount ($#) bigger then 0
	do
		if [ $1 = "--subfolders" ]; then
			noSubFolders=false
		elif [ $1 = "--start" ]; then
			startSet=true
			shift                  #move parameters $2->$1, $3->$2, $4->$3,...
			startPoint=$1
		elif [ $1 = "--end" ]; then
			endSet=true
			shift                  #move parameters $2->$1, $3->$2, $4->$3,...
			endPoint=$1
		elif [ $1 = "--help" ]; then
			echo
			echo "Usage: events_unifi_events.sh [CAMS] [OPTIONS]... [default:]Backup events from previous day"
			echo
			echo "OPTIONS:"
			echo "--help							Show this message and exit."
			echo "--subfolders						Video(s) will be put in subfolder yerr/month/day/cam/"
			echo "--start YYYY-MM-DDTHH:MM:SS		Period start"
			echo "--end YYYY-MM-DDTHH:MM:SS			Period end"
			echo
			echo "CAMS:           (if empty, events from all cams will be taken)"
			echo "Camera ID       e.g. 62d2f99003a7b303e70003zr (multible \"Camera IDs\" as seperate parameter)"
			echo
			echo "============================"
			echo "=        EXAMPELS          ="
			echo "============================"
			echo "  events_unifi_cams.sh 2d2f99003a7b303e70003zr 2d2f99003a7b303e78703zr --subfolders"
			echo "... will take events from both specifide cameras and puts the image files in subfolders"
			echo
			echo "  events_unifi_cams.sh"
			echo "... will take all events footage from yesterday and from all available cameras and puts all the images into the same folder"
			echo
			exit 0
		else
			allCams=false 		 #minimum one parameter present
			if [ $firstCam = true ]
				then
					cams=$1
					firstCam=false
				else
					cams+=,$1
			fi
		fi
	shift                  #move parameters $2->$1, $3->$2, $4->$3,...
done

if [ "$startSet" = 'true' ] || [ "$endSet" = 'true' ]; then
	if [ "$startSet" = 'false' ] || [ "$endSet" = 'false' ]; then
		echo "only period \"START\" or \"END\" is defined!"
		echo "if you define period, \"start\" AND \"end\" need to be specified"
		exit 5
	elif [ $(date --date="$startPoint" +%s) -gt $(date --date="$endPoint" +%s) ]; then
		echo "Period START is later than period END!"
		exit 5
	fi
fi

echo ===============================
echo Starting UniFi Protect Events
echo ===============================
date
if [ $allCams = true ]
then
	echo All cams
	cams=all
else
	echo Specific cam\(s\)\ $cams
fi

if [ $noSubFolders = true ]
then
	docker run -e TZ=$timeZone --name=$containername --volume $saveTarget:/downloads unifitoolbox/protect-archiver events --address=$deviceIP --username=$deviceUsername --password=$devicePassword --cameras=$cams --start=$startPoint --end=$endPoint --no-use-subfolders --touch-files /downloads
else
	docker run -e TZ=$timeZone --name=$containername --volume $saveTarget:/downloads unifitoolbox/protect-archiver events --address=$deviceIP --username=$deviceUsername --password=$devicePassword --cameras=$cams --start=$startPoint --end=$endPoint --touch-files /downloads
fi	

echo removing Docker container ...
docker container rm $containername
echo all done
